include:
  # OSV CI template
  - project: repos/security/gitlab-ci-security-templates
    ref: v0.1.5
    file: generic-osv/osv-ci.yaml
  - project: repos/releng/docpub
    file: includes/publish.yml

stages:
  - test-code
  - test-rollup
  - publish-coverage-report
  - test # This is required for OSV and is unfortunately non-configurable.

# Special AppSec template job from the Security team
variables:
  WM_APPSEC_GOLANG_IMAGE: "bookworm:20231015"

# Copied from https://gitlab.wikimedia.org/repos/mediawiki/services/ipoid/-/blob/main/.gitlab-ci.yml
# This workflow should alleviate the problem of 'double pipelines' run during merge request updates,
# by consolidating all jobs into a single merge_request pipeline
workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: $CI_COMMIT_BRANCH

test-node18:
  stage: test-code
  extends:
    - .docpub:build-docs
  variables:
    DOCS_DIR: coverage
  image:
    name: docker-registry.wikimedia.org/releng/node18-test:18.20.2
    entrypoint: [ "" ]
  script:
    - node --version
    - npm --version
    - npm ci
    - npm test
  artifacts:
    reports:
      coverage_report:
        coverage_format: cobertura
        path: coverage/cobertura-coverage.xml
  coverage: /(?i)total.*? (100(?:\.0+)?\%|[1-9]?\d(?:\.\d+)?\%)$/

test-node20:
  stage: test-code
  extends:
    - .docpub:build-docs
  variables:
    DOCS_DIR: coverage
  image:
    name: docker-registry.wikimedia.org/releng/node20-test:20.12.2
    entrypoint: [ "" ]
  script:
    - node --version
    - npm --version
    - npm ci
    - npm test

test-node22:
  stage: test-code
  extends:
    - .docpub:build-docs
  variables:
    DOCS_DIR: coverage
  image:
    name: docker-registry.wikimedia.org/releng/node22-test:22.0.0
    entrypoint: [ "" ]
  script:
    - node --version
    - npm --version
    - npm ci
    - npm test

test-rollup:
  stage: test-rollup
  image:
    name: docker-registry.wikimedia.org/releng/node20-test:20.12.2
    entrypoint: [ "" ]
  script:
    - npm install
    - npm run test:rollup

publish-coverage-report:
  stage: publish-coverage-report
  extends:
    - .docpub:publish-docs
  variables:
    COVERAGE: "true"
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_COMMIT_REF_PROTECTED
